$__author__ = "Chelsio Communications <support@chelsio.com>"
$Global:__version__ = "4.0"
$Global:__is_nano  = "empty"
$Global:__ch_cards = @{
    # For internal use only don't modify this.
}

$Global:__ch_parts = @{
}

$Global:__ch_vpd_map = @{
}

$Global:__ch_vpd_revmap = @{
}


$Global:__sys_drive = (Get-ChildItem Env:\SystemDrive).Value

$Global:__vpd_default = @{

        "T580-CR"      = "t580_cr_variable_2133_vpd.bin";
        "T580-LP-CR"   = "t580_lp_cr_variable_2133_vpd.bin";
        "T580-LP-SO"   = "t580_lp_so_variable_vpd.bin";
	"T580-SO"      = "t580_lp_so_variable_vpd.bin";
        "T580-OCP-SO"  = "t580_ocp_so_2x40g_vpd.bin";
        "T6225-CR"     = "t6225_cr_variable_2133_15625_2x25g_vpd_mfg.bin";
        "T6-DBG-25"    = "t6_dbg_25_fixed_2133ddr3_15625_2x25g_vpd.bin";
        "T62100-LP-CR" = "t62100_lp_cr_variable_2133_15625_2x100g_vpd_mfg.bin";
        "T6-DBG-100"   = "t6_dbg_100_fixed_2133ddr4_15625_2x100g_vpd.bin";
	"T6425-CR"     = "t6425_cr_variable_2133_15625_2x25g_vpd_mfg.bin";
	"T6225-LL-CR"  = "t6225_ll_cr_variable_2133_15625_2x25g_vpd_mfg.bin";

}

$Global:__vpd_spider = @{
        
        "T580-CR"      = "t580_cr_spider_variable_2133_vpd.bin";
        "T580-LP-CR"   = "t580_lp_cr_spider_variable_2133_vpd.bin";
        "T580-LP-SO"   = "t580_so_spider_variable_2133_vpd.bin";
        "T580-SO"      = "t580_so_spider_variable_2133_vpd.bin";
        "T580-OCP-SO"  = "t580_ocp_so_4x10g_vpd.bin";
        "T62100-LP-CR" = "t62100_lp_cr_spider_variable_vpd.bin";
        "T6-DBG-100"   = "t6_dbg_100_spider_variable_vpd.bin";
}

$Global:__vpd_qsa = @{
    
        "T580-CR"    	= "t580_cr_qsa_variable_2133_vpd.bin";
        "T580-LP-CR" 	= "t580_lp_cr_qsa_variable_2133_vpd.bin";
        "T580-LP-SO" 	= "t580_lp_so_qsa_variable_vpd.bin";
	"T580-SO" 	= "t580_lp_so_qsa_variable_vpd.bin";
        "T62100-LP-CR" 	= "t62100_lp_cr_qsa_variable_vpd.bin";
        "T6-DBG-100"  	= "t6_dbg_100_qsa_variable_vpd.bin";
}

$Global:__sriov = @{

       "T502-BT"    	= "t502_bt_init_gen3_150mhz_Pf4vf.bin";
       "T520-BT"    	= "t520_bt_init_gen3_250_820_Pf4vf.bin";
       "T520-CR"    	= "t520_cr_init_gen3_250_825_Pf4vf.bin";
       "T520-LL" 	= "t520_ll_init_gen3_650_1075_Pf4vf.bin";
       "T520-SO"    	= "t520_so_init_gen3_250_825_Pf4vf.bin";
       "T522-CR"    	= "t522_cr_init_gen3_500mhz_Pf4vf.bin";
       "T540-CR"    	= "t540_cr_init_gen3_500_825_Pf4vf.bin";
       "T580-CR"    	= "t580_cr_init_gen3_500Mhz_Pf4vf.bin";
       "T580-LP-CR" 	= "t580_lp_cr_init_gen3_500Mhz_Pf4vf.bin";
       "T580-LP-SO" 	= "t580_lp_so_init_gen3_500Mhz_Pf4vf.bin";
       "T580-SO" 	= "t580_lp_so_init_gen3_500Mhz_Pf4vf.bin";
       "T580-OCP-SO"	= "t580_ocp_so_init_gen3_500Mhz_Pf4vf.bin";
       "T520-OCP-SO"	= "t520_ocp_init_gen3_250_825_Pf4vf.bin";
       "T540-BT"    	= "t540_bt_init_gen3_500_820_Pf4vf.bin";
       "T540-LP-CR"     = "t540_lp_cr_init_gen3_500_825_Pf4vf.bin";
       "T540-SO-CR"     = "t540_so_cr_init_gen3_500_825_Pf4vf.bin";
       "T6225-CR"   	= "t6225_cr_init_500_950_gen3_x8_mfg_pf4vf.bin";
       "T6225-SO"	= "t6225_so_cr_init_500_950_gen3_x8_mfg_pf4vf.bin";
       "T6-DBG-25"  	= "t6_dbg_25_init_450_950_gen3_x8_pf4vf.bin";
       "T62100-CR"  	= "t62100_cr_init_800_1050_gen3_x16_mfg_pf4vf.bin";
       "T62100-LP-CR" 	= "t62100_lp_cr_init_800_1050_gen3_x16_mfg_pf4vf.bin";
       "T62100-SO-CR" 	= "t62100_so_cr_init_800_1050_gen3_x16_mfg_pf4vf.bin";
       "T6-DBG-100"  	= "t6_dbg_100_init_800_950_gen3_x16_pf4vf.bin";
       "T6425-CR" 	= "t6425_cr_init_250_950_gen3_x4_mfg_pf4vf.bin";
       "T6225-LL-CR" 	= "t6225_ll_cr_init_800_1050_gen3_x8_mfg_pf4vf.bin";
}


$Global:__default_init = @{
    
       "T502-BT"    	= "t502_bt_init_gen3_150mhz.bin";
       "T520-BT"     	= "t520_bt_init_gen3_250_820.bin";
       "T520-CR"    	= "t520_cr_init_gen3_250_825.bin";
       "T520-LL" 	= "t520_ll_init_gen3_650_1075.bin";
       "T520-SO"    	= "t520_so_init_gen3_250_825.bin";
       "T522-CR"    	= "t522_cr_init_gen3_500mhz.bin";
       "T540-CR"    	= "t540_cr_init_gen3_500_825.bin";
       "T580-CR"    	= "t580_cr_init_gen3_500Mhz.bin";
       "T580-LP-CR" 	= "t580_lp_cr_init_gen3_500Mhz.bin";
       "T580-LP-SO"        = "t580_lp_so_init_gen3_500Mhz.bin";
       "T580-SO"        = "t580_lp_so_init_gen3_500Mhz.bin";	
       "T580-OCP-SO"	= "t580_ocp_so_init_gen3_500Mhz.bin";
       "T520-OCP-SO"	= "t520_ocp_init_gen3_250_825.bin";
       "T540-BT"    	= "t540_bt_init_gen3_500_820.bin";
       "T540-LP-CR"     = "t540_lp_cr_init_gen3_500_825.bin";
       "T540-SO-CR"     = "t540_so_cr_init_gen3_500_825.bin";
       "T6225-CR"   	= "t6225_cr_init_500_950_gen3_x8_mfg.bin";
       "T6-DBG-25"  	= "t6_dbg_25_init_450_950_gen3_x8_mfg.bin";
       "T62100-CR"  	= "t62100_cr_init_800_1050_gen3_x16_mfg.bin";
       "T6225-SO"     	= "t6225_so_cr_init_500_950_gen3_x8_mfg.bin";
       "T62100-LP-CR" 	= "t62100_lp_cr_init_800_1050_gen3_x16_mfg.bin";
       "T62100-SO-CR" 	= "t62100_so_cr_init_800_1050_gen3_x16_mfg.bin";
       "T6-DBG-100"  	= "t6_dbg_100_init_800_950_gen3_x16.bin";
       "T6425-CR" 	= "t6425_cr_init_250_950_gen3_x4_mfg.bin";
       "T6225-LL-CR" 	= "t6225_ll_cr_init_800_1050_gen3_x8_mfg.bin";
}

$Global:device_map = @{

        # Maps device ids to human readable names.

        "B000"    = "Bypass Mode";
        "5400"    = "T580-dbg";
        "5401"    = "T520-CR";
        "5402"    = "T522-CR";
        "5403"    = "T540-CR";
        "5404"    = "T520-BCH";
        "5405"    = "T540-BCH";
        "5406"    = "T540-CH";
        "5407"    = "T520-SO";
        "5408"    = "T520-CX";
        "5409"    = "T520-BT";
        "540A"    = "T504-BT";
        "540B"    = "B520-SR";
        "540C"    = "B504-BT";
        "540D"    = "T580-CR";
        "540E"    = "T540-LP-CR";
        "540F"    = "Amsterdam";

        "5410"    = "T580-LP-CR";
        "5411"    = "T520-LL";
        "5412"    = "T560-CR";
        "5413"    = "T580-CHR";
        "5414"    = "T580-LP-SO";
        "5415"    = "T502-BT";
        "5416"    = "T580-OCP-SO";
        "5417"    = "T520-OCP-SO";
        "5418"    = "T540-BT";
        "541B"    = "T540-SO-CR";

        "5480"    = "SECUI";
        "5481"    = "SECUI-LL";
        "5482"    = "SECUI-1G";

        "5483"    = "HUAWEI-T540-CANCELED";
        "5484"    = "HUAWEI-T580-CALCELED";
        "5485"    = "HUAWEI-3XT580-CANCELED";
        "5486"    = "HUAWEI-2XT580";
        "5487"    = "Dell Harpoon";
        "5488"    = "Xalyo T570";
        "5489"    = "KTFN T520";
        "5490"    = "KTFN T540";

        "5491"    = "Huawei T522 LOM";
        "5492"    = "Datawise T520-XFI";
        "6401"    = "T6225-CR";
        "6402"    = "T6225-SO";
        "6400"    = "T6-DBG-25";
        "6407"    = "T62100-LP-CR";
        "6408"    = "T62100-SO-CR";
        "640D"    = "T62100-CR";
        "6410"    = "T6-DBG-100";
        "6403"    = "T6425-CR";
		"6411"	  = "T6225-LL-CR";
        <#
        "5800"    = "";
        "5801"    = "";
        "5802"    = "";
        "5803"    = "";
        "5804"    = "";
        "5805"    = "";
        "5806"    = "";
        "5807"    = "";
        "5808"    = "";
        "5809"    = "";
        "580A"    = "";
        "580B"    = "";
        "580C"    = "";
        "580D"    = "";
        "580E"    = "";
        "5810"    = "";
        "5811"    = "";
        "5812"    = "";
        "5813"    = "";
        "5814"    = "";
        "5815"    = "";
        "5816"    = "";
        "5817"    = "";
        "5818"    = "";
        "5880"    = "";
        "5881"    = "";
        "5883"    = "";
        "5884"    = "";
        "5885"    = "";
        "5886"    = "";
        "5887"    = "";
        "5888"    = "";
        "5889"    = "";
        "5890"    = "";
        #>
        
}

function is_cxgbtool_present ()
{
        return Test-Path C:\Windows\System32\cxgbtool.exe
}
  
function is_cxgbnano_present()
{
        return Test-Path C:\Windows\System32\cxgbnano.exe
}

function is_ms_nano_server()
{
        
        <#if ($Global:__is_nano -eq "empty") {
            Write-Host "    1.  Windows GUI"
            Write-Host "    2.  Windows Nano Server"
            $Global:__is_nano = READ-HOST 'Input'

        }

        if ($Global:__is_nano -eq '1') {
            return 0
        }
        elseif ($Global:__is_nano -eq '2') {
            return 1
        }
        else {
            Write-Host "Wrong input"
            exit(1)
        }#>
		return 0
        
}

function get_cxgbtool()
{
    if (is_ms_nano_server) {
        return "cxgbnano.exe"
    }
    else {
        return "cxgbtool.exe"
    }
}

function get_chelsio_card_count ()
{
        $out = Get-PnpDevice -FriendlyName "*Chelsio*Enumerator" -Status OK -ErrorAction SilentlyContinue
        return ($out | Measure-Object).Count
}
        
        

function __extract_devid ([string] $str)
{
        
        $tmp = $str -replace '\s+:\s+', ' '
        return $tmp.Split(' ')[1].trim().ToString()
}


function __extract_partno ([string] $str)
{
        
        $tmp = $str -replace '\s+:\s+', ' '
        return $tmp.Split(' ')[2].trim().ToString()
}


function get_pci_device ([int] $num)
{ 
        $cmd = "$(get_cxgbtool) vbd$num boot vpdparams"
        $out = Invoke-Expression -Command $cmd
        for ($i=0; $i -le $out.Length-1; $i++){
                if ($out[$i].Contains("Id") -eq $true){
                        $dev_id = __extract_devid $out[$i]
                }

                if ($out[$i].Contains("Serial Number") -eq $true){
                        $part = __extract_partno $out[$i]
                }
        }
        return $dev_id, $part
}


function __is_chelsio_card ([string] $device)
{
	$t580_so = "T580-SO"

        foreach ( $key in ($device_map.GetEnumerator())){
                if ($device.ToLower().Contains($key.value.ToLower())){
                    return $true, $key.value
            }
        }

	#T580-SO-CR cards have two names (T580-SO & T580-LP-SO)in vpd files as an exception 
        #so added a check to return card name in case one is not there in device_map
	if ($device.ToLower().Contains($t580_so.ToLower())) {
		return $true, $t580_so
	}

	return $false, ""	

}


function __add_device ([int] $vpd_count, [int]$count, [string] $name, [string] $part)
{
        $Global:__ch_cards.Add($vpd_count, $name)
        $Global:__ch_parts.Add($vpd_count, "S/N:" + $part)
        $Global:__ch_vpd_map.Add($vpd_count, $count)
        $Global:__ch_vpd_revmap.Add($count, $vpd_count)
}


function filter_chelsio_card ([int] $count)
{
        $chelsio_card_count = 0
        for ($i=0; $i -lt $count; $i++){
                $dev, $part = get_pci_device($i)
                $st, $name = __is_chelsio_card ($dev)
                if ($st -eq $true) {
                        __add_device $i $chelsio_card_count $name $part
                        $chelsio_card_count +=1
                }

        }
}

function choose_adapter ()
{
        Write-Host "`nSelect the Adapter"
        foreach ( $key in ($__ch_cards.GetEnumerator() | Sort-Object Name)){
                $cnt = [convert]::ToInt32($key.name, 10)              
                $display = $Global:__ch_vpd_map.Item($cnt) +1
                $tmp = "{0,7}{1,2}{2,1}{3,-15}{4,-18}" -f ` "", $display, ".", $key.value, $Global:__ch_parts.Item($cnt)
           
                Write-Host $tmp
        } 

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input to select adapter"
                exit (1)
        }

        if (-Not ($choice -ge 1 -and $choice -le  $__ch_cards.Count)){
                Write-Host "Please enter valid input to select adapter"
                exit (1)
        }

        return $Global:__ch_vpd_revmap.item($choice-1)


}

function is_t6([string] $adapter_name)
{
        if ($adapter_name[1] -eq '6') {
                return 1
        }

        return 0;
}

function is_t62100([string] $adapter_name)
{
        if($adapter_name -match "T6.*100.*"){
                return 1
        }

        return 0
}

function is_t6225([string] $adapter_name)
{
        if($adapter_name -match "T6.*225.*"){
                return 1
        }

        return 0
}

function is_t580([string] $adapter_name)
{
        if($adapter_name[2] -eq '8' -and $adapter_name[3] -eq '0'){
                return 1
        }
        return 0;

}

function choose_vpd([string] $adapter_name)
{
        Write-Host "`nChoose the type:"
        Write-Host "`t1. DEFAULT [T5(2 * 40G)/ T6(2 * 100)]"
        $t6225 = is_t6225 $adapter_name
        if (!$t6225) {
                Write-Host "`t2. SPIDER  [T5(4 x 10G)/ T6 (NA)]"
                Write-Host "`t3. QSA     [T5(2 x 10G)/ T6 (NA)]"
        }
        
        $adapter_name = $Global:__ch_cards.Item($adapter)  

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input !!"
                exit (1)
        }
        if ($choice -ne 1 -and $choice -ne 2 -and $choice -ne 3){
                Write-Host "Please enter valid input !!"
                exit(1)
        }

        if ($adapter_name -eq "T580-OCP-SO" -and $choice -eq 3) {
                Write-Host "QSA is not supported for T580-OCP-SO"
                exit(1)
        }


        if (is_t6225($adapter_name)) {
            if ($choice -gt 1) {
                    Write-Host "Wrong Input" -ForegroundColor Red
                    exit(1)
            }
        }

        if (is_t62100($adapter_name)) {
                if ($choice -gt 1) {
                        Write-Host "SPIDER/QSA is not supported in T6 yet" -ForegroundColor Red
                        exit(1)
                }
        }
        return $choice
}

function choose_init ()
{
        Write-Host "`nChoose the configuration type:"
        Write-Host "`t1. NON-SRIOV (Default)"
        Write-Host "`t2. SRIOV"
        
        $adapter_name = $Global:__ch_cards.Item($adapter)
        
        $t580 = is_t580 $adapter_name
        $t6 = is_t6 $adapter_name
        #if ($t580 -or $t6 ){
        if ($t580){
                Write-Host "`t3. Port settings"
        }

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input !!"
                exit (1)
        }
        if ($choice -ne 1 -and $choice -ne 2 -and $choice -ne 3){
                Write-Host "Please enter valid input !!"
                exit(1)
        }
        
        #if (is_t6($adapter_name)) {
        #        if ($choice -eq 2) {
        #                Write-Host "SRIOV is not supported in T6 yet"
        #                exit(1)
        #        }
        #}

        return $choice
}

function __yes_no_flash ()
{
        $choice = Read-Host "Do you want to continue (y/n)"

        Set-Content tmp $choice
        if ($choice  -eq 'y' -or $choice -eq 'Y'){
                return $true
        }
        if ($choice -ne 'n' -and $choice -ne 'N'){
                Write-Host "Invalid input!"
        }
        
        Remove-Item tmp
        exit(1)
}
    
function __flash ($vpd, $path)
{     
        $out = __verify $vpd $path $false
        if ( ($out -join '`n').Contains("FAILED") -eq $false) {
                Write-Host "`nThe selected configuration is already present." -ForegroundColor Green
                exit(0)
        }

        $out = [string]

        # Exit if the user says not to flash
        $choice = __yes_no_flash 
 
        $path = "`"$path`""
        # Start the process and attact the user input as the
        # standard input file. 
        
        if ( is_ms_nano_server ) {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,boot,serialinit,write,$path,force -RedirectStandardInput tmp -RedirectStandardOutput out0 -wait -NoNewWindow
        }
        else {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,boot,serialinit,write,$path -RedirectStandardInput tmp -RedirectStandardOutput out0 -wait -NoNewWindow
        }

        $out = Get-Content out0
        #Write-Host `n

        Remove-Item tmp
        Remove-Item out0
        
        if ( ($out -join '`n').Contains('fail') -eq $true){
                Write-Host "Flashing failed with error `n $out" -ForegroundColor Red
                exit(1)
        }
       
}

function __flash_vpd ($vpd, $path)
{     
        $out = __verify_vpd $vpd $path $false
        if ( ($out -join '`n').Contains("FAILED") -eq $false) {
                Write-Host "`nThe selected configuration is already present." -ForegroundColor Green
                exit(0)
        }

        $out = [string]

        # Exit if the user says not to flash
        $choice = __yes_no_flash 
 
        $path = "`"$path`""
        # Start the process and attact the user input as the
        # standard input file. 
        if ( is_ms_nano_server ) {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,boot,vpd,write,$path,force -RedirectStandardInput tmp -RedirectStandardOutput out0 -Wait -NoNewWindow
        }
        else {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,boot,vpd,write,$path -RedirectStandardInput tmp -RedirectStandardOutput out0 -Wait -NoNewWindow
        } 

        $out = Get-Content out0
      
        Remove-Item tmp
        Remove-Item out0
      
        if ( ($out -join '`n').Contains('fail') -eq $true){
                Write-Host "Flashing failed with error `n $out" -ForegroundColor Red
                exit(1)
        }
       
}

function __verify_vpd ($vpd, $path, $debug)
{
      
        #if ( $debug -eq $true){
        #        Write-Host -NoNewline "`nVerifying the existing configuration... " -ForegroundColor Green
        #}

        $cmd = "$(get_cxgbtool) vbd$vpd boot vpd verify `"$path`""
        
        $out = Invoke-Expression -Command $cmd 
       
        return $out

}


function __verify ($vpd, $path, $debug)
{
      
        #if ( $debug -eq $true){
        #        Write-Host -NoNewline "`nVerifying the existing configuration... " -ForegroundColor Green
        #}

        $cmd = "$(get_cxgbtool) vbd$vpd boot serialinit verify `"$path`""
        $out = Invoke-Expression -Command $cmd 
        #Write-Host $cmd
        return $out

}

function __get_default_init ([string] $adapter_name)
{
        $file_name = $Global:__default_init.Item($adapter_name)
        if (!$file_name) {
             Write-Host "Init file not provided"
             exit(1)   
        }

        if ( (Test-Path  "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\default\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\default\$file_name"
        }
        elseif ( (Test-Path ".\default\$file_name") -eq $true){
                return  ".\default\$file_name"
        }
        else {
                return $file_name
        }
}


function __get_sriov  ([string] $adapter_name)
{

        $file_name = $Global:__sriov.Item($adapter_name)

        if ( (Test-Path "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\SRIOV\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\SRIOV\$file_name"
        }
        elseif ( (Test-Path ".\SRIOV\$file_name") -eq $true){
                return  ".\SRIOV\$file_name"
        }
        else {
                return $file_name
        }
}

 
function __check_init_path ($path)
{
        $ret = Test-Path $path 
        if ($ret -eq $false){
                Write-Host "Unable to find the bin file." -ForegroundColor Red
                exit (1)
        }

}

function __get_vpd([string] $adapter_name, [int] $vpd_choice)
{

        if ($vpd_choice -eq 1){
                $file_name = $Global:__vpd_default.Item($adapter_name)
                                
        }
        elseif ($vpd_choice -eq 2){
                 $file_name = $Global:__vpd_spider.Item($adapter_name)
        }
        elseif ($vpd_choice -eq 3){
                 $file_name = $Global:__vpd_qsa.Item($adapter_name)
        }
        if (!$file_name) {
            Write-Host "VPD File not provided"
            exit(1)
        }
       
        if ( (Test-Path "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\Port Settings\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\Port` Settings\$file_name"
        }
        elseif ( (Test-Path ".\Port Settings\$file_name") -eq $true){
                return  ".\Port` Settings\$file_name"
        }
        else {
                return $file_name
        }
}

function flash ([int] $adapter, [int] $init)
{
        $adapter_name = $Global:__ch_cards.Item($adapter)
        $t5 = is_t580 $adapter_name
        $t6 = is_t6 $adapter_name
        
        if ($init -eq 1){
                $init_file = __get_default_init ($adapter_name)    
        }elseif ($init -eq 2){
                $init_file = __get_sriov ($adapter_name)
                #Write-Host "adap $adapter_name"
                #Write-Host "sriov init $init_file"
                
        }elseif ($init -eq 3 -and ($t5 -or $t6)){
                $vpd_choice = choose_vpd $adapter_name
                $init_file = __get_vpd $adapter_name $vpd_choice            

        }else {
                Write-Host "Please Enter valid input !!!"
                exit(1)
        }

        __check_init_path ($init_file)
        
        if ($init -eq 3){
                __flash_vpd $adapter $init_file
                $out = __verify_vpd $adapter $init_file $true
        }else {
                __flash $adapter $init_file
                $out = __verify $adapter $init_file $true
        }
        
        #Write-Host $out
        if (($out -join '`n').Contains("FAILED")) {
                #Write-Host $out
                Write-Host "`nVerification Failed." -ForegroundColor Red
                exit(1)
        }
        else {
                Write-Host "Successfully updated the selected configuration type." -ForegroundColor Green
                Write-Host "`nVerification: Passed" -ForegroundColor Green
                Write-Host "`nPlease reboot the machine for changes to take effect." -ForegroundColor Red
        }
}

function main (){

        if ((is_ms_nano_server) -and ((is_cxgbnano_present) -eq $false) ) {
                Write-Host "cxgbnano is not present in system32 folder." -ForegroundColor Red
                exit(1)
        }


        if (!(is_ms_nano_server) -and ((is_cxgbtool_present ) -eq $false)){
                Write-Host "cxgbtool is not present in system32 folder." -ForegroundColor Red
                exit(1)
        }
        
        Write-Host "`nchelsio_adapter_config Version $Global:__version__`n"
        Write-Host "Please stop all the traffic on Chelsio adapters before updating !!" -ForegroundColor Red
        $count = get_chelsio_card_count
        if ($count -eq 0) {
            Write-Host "Chelsio adapter are in disabled state or not present" -f Red
            exit(1)
        }
        filter_chelsio_card ($count)
        $adapter = choose_adapter
        $init = choose_init
 
        flash $adapter $init
}

main 

# SIG # Begin signature block
# MIIcrAYJKoZIhvcNAQcCoIIcnTCCHJkCAQExDzANBglghkgBZQMEAgEFADB5Bgor
# BgEEAYI3AgEEoGswaTA0BgorBgEEAYI3AgEeMCYCAwEAAAQQH8w7YFlLCE63JNLG
# KX7zUQIBAAIBAAIBAAIBAAIBADAxMA0GCWCGSAFlAwQCAQUABCAuCVHNCpWOOFYF
# giarZ6xRH3KbOaDrA2URXWlsnzDSQKCCF78wggUwMIIEGKADAgECAhAECRgbX9W7
# ZnVTQ7VvlVAIMA0GCSqGSIb3DQEBCwUAMGUxCzAJBgNVBAYTAlVTMRUwEwYDVQQK
# EwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xJDAiBgNV
# BAMTG0RpZ2lDZXJ0IEFzc3VyZWQgSUQgUm9vdCBDQTAeFw0xMzEwMjIxMjAwMDBa
# Fw0yODEwMjIxMjAwMDBaMHIxCzAJBgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2Vy
# dCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xMTAvBgNVBAMTKERpZ2lD
# ZXJ0IFNIQTIgQXNzdXJlZCBJRCBDb2RlIFNpZ25pbmcgQ0EwggEiMA0GCSqGSIb3
# DQEBAQUAA4IBDwAwggEKAoIBAQD407Mcfw4Rr2d3B9MLMUkZz9D7RZmxOttE9X/l
# qJ3bMtdx6nadBS63j/qSQ8Cl+YnUNxnXtqrwnIal2CWsDnkoOn7p0WfTxvspJ8fT
# eyOU5JEjlpB3gvmhhCNmElQzUHSxKCa7JGnCwlLyFGeKiUXULaGj6YgsIJWuHEqH
# CN8M9eJNYBi+qsSyrnAxZjNxPqxwoqvOf+l8y5Kh5TsxHM/q8grkV7tKtel05iv+
# bMt+dDk2DZDv5LVOpKnqagqrhPOsZ061xPeM0SAlI+sIZD5SlsHyDxL0xY4PwaLo
# LFH3c7y9hbFig3NBggfkOItqcyDQD2RzPJ6fpjOp/RnfJZPRAgMBAAGjggHNMIIB
# yTASBgNVHRMBAf8ECDAGAQH/AgEAMA4GA1UdDwEB/wQEAwIBhjATBgNVHSUEDDAK
# BggrBgEFBQcDAzB5BggrBgEFBQcBAQRtMGswJAYIKwYBBQUHMAGGGGh0dHA6Ly9v
# Y3NwLmRpZ2ljZXJ0LmNvbTBDBggrBgEFBQcwAoY3aHR0cDovL2NhY2VydHMuZGln
# aWNlcnQuY29tL0RpZ2lDZXJ0QXNzdXJlZElEUm9vdENBLmNydDCBgQYDVR0fBHow
# eDA6oDigNoY0aHR0cDovL2NybDQuZGlnaWNlcnQuY29tL0RpZ2lDZXJ0QXNzdXJl
# ZElEUm9vdENBLmNybDA6oDigNoY0aHR0cDovL2NybDMuZGlnaWNlcnQuY29tL0Rp
# Z2lDZXJ0QXNzdXJlZElEUm9vdENBLmNybDBPBgNVHSAESDBGMDgGCmCGSAGG/WwA
# AgQwKjAoBggrBgEFBQcCARYcaHR0cHM6Ly93d3cuZGlnaWNlcnQuY29tL0NQUzAK
# BghghkgBhv1sAzAdBgNVHQ4EFgQUWsS5eyoKo6XqcQPAYPkt9mV1DlgwHwYDVR0j
# BBgwFoAUReuir/SSy4IxLVGLp6chnfNtyA8wDQYJKoZIhvcNAQELBQADggEBAD7s
# DVoks/Mi0RXILHwlKXaoHV0cLToaxO8wYdd+C2D9wz0PxK+L/e8q3yBVN7Dh9tGS
# dQ9RtG6ljlriXiSBThCk7j9xjmMOE0ut119EefM2FAaK95xGTlz/kLEbBw6RFfu6
# r7VRwo0kriTGxycqoSkoGjpxKAI8LpGjwCUR4pwUR6F6aGivm6dcIFzZcbEMj7uo
# +MUSaJ/PQMtARKUT8OZkDCUIQjKyNookAv4vcn4c10lFluhZHen6dGRrsutmQ9qz
# sIzV6Q3d9gEgzpkxYz0IGhizgZtPxpMQBvwHgfqL2vmCSfdibqFT+hKUGIUukpHq
# aGxEMrJmoecYpJpkUe8wggVIMIIEMKADAgECAhAGmZTzAJqiFtG3c+lnMxKsMA0G
# CSqGSIb3DQEBCwUAMHIxCzAJBgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2VydCBJ
# bmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xMTAvBgNVBAMTKERpZ2lDZXJ0
# IFNIQTIgQXNzdXJlZCBJRCBDb2RlIFNpZ25pbmcgQ0EwHhcNMjAwNjE3MDAwMDAw
# WhcNMjIwNjIyMTIwMDAwWjCBhDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCkNhbGlm
# b3JuaWExEjAQBgNVBAcTCVN1bm55dmFsZTElMCMGA1UEChMcQ2hlbHNpbyBDb21t
# dW5pY2F0aW9ucywgSW5jLjElMCMGA1UEAxMcQ2hlbHNpbyBDb21tdW5pY2F0aW9u
# cywgSW5jLjCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJoFMVO1YynQ
# O9CxsCta6OR3nsOxk6F2UmCMPGdCMiaKOpXQ+3YmA2Lmh4EFIS/OrWSOpfRV5RFn
# VlDgteJTgG5vkBybFqCGiLiJLgGUBSIG4Q6yeELeMytKxXqmL1pSViODyaQOwf6y
# YhfcIiFHx4phU5/MxXXUZV1LiKB7YZIfias/a9cTmgbeAohvDCd9D+rTRefynbeY
# UxyBt8j1ORWu5TECKhdCZIDLYdWBvNr9XXyDFRc6R0l8CLgXWm5W622BatCA5Sww
# 3wxSJ1UYFudPR/NSfKcRNV2RCA8yibEu2v9YtF6/B54tBBgI0HFkWPg7iPVCVLZB
# 9NEgm0oxACMCAwEAAaOCAcUwggHBMB8GA1UdIwQYMBaAFFrEuXsqCqOl6nEDwGD5
# LfZldQ5YMB0GA1UdDgQWBBSplxzR7ZLP8CY03iEYFpARa8i7lTAOBgNVHQ8BAf8E
# BAMCB4AwEwYDVR0lBAwwCgYIKwYBBQUHAwMwdwYDVR0fBHAwbjA1oDOgMYYvaHR0
# cDovL2NybDMuZGlnaWNlcnQuY29tL3NoYTItYXNzdXJlZC1jcy1nMS5jcmwwNaAz
# oDGGL2h0dHA6Ly9jcmw0LmRpZ2ljZXJ0LmNvbS9zaGEyLWFzc3VyZWQtY3MtZzEu
# Y3JsMEwGA1UdIARFMEMwNwYJYIZIAYb9bAMBMCowKAYIKwYBBQUHAgEWHGh0dHBz
# Oi8vd3d3LmRpZ2ljZXJ0LmNvbS9DUFMwCAYGZ4EMAQQBMIGEBggrBgEFBQcBAQR4
# MHYwJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3NwLmRpZ2ljZXJ0LmNvbTBOBggrBgEF
# BQcwAoZCaHR0cDovL2NhY2VydHMuZGlnaWNlcnQuY29tL0RpZ2lDZXJ0U0hBMkFz
# c3VyZWRJRENvZGVTaWduaW5nQ0EuY3J0MAwGA1UdEwEB/wQCMAAwDQYJKoZIhvcN
# AQELBQADggEBAD/oM1e3Wc+4aOZywjdnpOMkTO48nVTVoKfDkHmsW+ADrcyvpo9Z
# lp4PUvECUbfc5ifOcB+uHQiDnY2Cn/btLSkYD1OUVKuoDxgbknj0rsQ604j25Kv7
# yAPFS7eefrLFVitc0HuwDvNN/qk4jRQj5YZ5CsQKge8XXcTLVWAFQtmWznm2ADkg
# hBpp375IsG4sTRyYHFjK7j+A87tUg3YYk0o04asQpu9/K/br64NKa3ztxDSVms+0
# kDNHe+tJpXPeSfQetas0QdD/O5YRxaj6JWWh0qOHvnD/ork4/oXeBOEel16qSaAL
# /Lcsw2Kgw9XSLO2Wn9AkX3fqzm9/1IGgWKwwggZqMIIFUqADAgECAhADAZoCOv9Y
# sWvW1ermF/BmMA0GCSqGSIb3DQEBBQUAMGIxCzAJBgNVBAYTAlVTMRUwEwYDVQQK
# EwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xITAfBgNV
# BAMTGERpZ2lDZXJ0IEFzc3VyZWQgSUQgQ0EtMTAeFw0xNDEwMjIwMDAwMDBaFw0y
# NDEwMjIwMDAwMDBaMEcxCzAJBgNVBAYTAlVTMREwDwYDVQQKEwhEaWdpQ2VydDEl
# MCMGA1UEAxMcRGlnaUNlcnQgVGltZXN0YW1wIFJlc3BvbmRlcjCCASIwDQYJKoZI
# hvcNAQEBBQADggEPADCCAQoCggEBAKNkXfx8s+CCNeDg9sYq5kl1O8xu4FOpnx9k
# WeZ8a39rjJ1V+JLjntVaY1sCSVDZg85vZu7dy4XpX6X51Id0iEQ7Gcnl9ZGfxhQ5
# rCTqqEsskYnMXij0ZLZQt/USs3OWCmejvmGfrvP9Enh1DqZbFP1FI46GRFV9GIYF
# jFWHeUhG98oOjafeTl/iqLYtWQJhiGFyGGi5uHzu5uc0LzF3gTAfuzYBje8n4/ea
# 8EwxZI3j6/oZh6h+z+yMDDZbesF6uHjHyQYuRhDIjegEYNu8c3T6Ttj+qkDxss5w
# RoPp2kChWTrZFQlXmVYwk/PJYczQCMxr7GJCkawCwO+k8IkRj3cCAwEAAaOCAzUw
# ggMxMA4GA1UdDwEB/wQEAwIHgDAMBgNVHRMBAf8EAjAAMBYGA1UdJQEB/wQMMAoG
# CCsGAQUFBwMIMIIBvwYDVR0gBIIBtjCCAbIwggGhBglghkgBhv1sBwEwggGSMCgG
# CCsGAQUFBwIBFhxodHRwczovL3d3dy5kaWdpY2VydC5jb20vQ1BTMIIBZAYIKwYB
# BQUHAgIwggFWHoIBUgBBAG4AeQAgAHUAcwBlACAAbwBmACAAdABoAGkAcwAgAEMA
# ZQByAHQAaQBmAGkAYwBhAHQAZQAgAGMAbwBuAHMAdABpAHQAdQB0AGUAcwAgAGEA
# YwBjAGUAcAB0AGEAbgBjAGUAIABvAGYAIAB0AGgAZQAgAEQAaQBnAGkAQwBlAHIA
# dAAgAEMAUAAvAEMAUABTACAAYQBuAGQAIAB0AGgAZQAgAFIAZQBsAHkAaQBuAGcA
# IABQAGEAcgB0AHkAIABBAGcAcgBlAGUAbQBlAG4AdAAgAHcAaABpAGMAaAAgAGwA
# aQBtAGkAdAAgAGwAaQBhAGIAaQBsAGkAdAB5ACAAYQBuAGQAIABhAHIAZQAgAGkA
# bgBjAG8AcgBwAG8AcgBhAHQAZQBkACAAaABlAHIAZQBpAG4AIABiAHkAIAByAGUA
# ZgBlAHIAZQBuAGMAZQAuMAsGCWCGSAGG/WwDFTAfBgNVHSMEGDAWgBQVABIrE5iy
# mQftHt+ivlcNK2cCzTAdBgNVHQ4EFgQUYVpNJLZJMp1KKnkag0v0HonByn0wfQYD
# VR0fBHYwdDA4oDagNIYyaHR0cDovL2NybDMuZGlnaWNlcnQuY29tL0RpZ2lDZXJ0
# QXNzdXJlZElEQ0EtMS5jcmwwOKA2oDSGMmh0dHA6Ly9jcmw0LmRpZ2ljZXJ0LmNv
# bS9EaWdpQ2VydEFzc3VyZWRJRENBLTEuY3JsMHcGCCsGAQUFBwEBBGswaTAkBggr
# BgEFBQcwAYYYaHR0cDovL29jc3AuZGlnaWNlcnQuY29tMEEGCCsGAQUFBzAChjVo
# dHRwOi8vY2FjZXJ0cy5kaWdpY2VydC5jb20vRGlnaUNlcnRBc3N1cmVkSURDQS0x
# LmNydDANBgkqhkiG9w0BAQUFAAOCAQEAnSV+GzNNsiaBXJuGziMgD4CH5Yj//7HU
# aiwx7ToXGXEXzakbvFoWOQCd42yE5FpA+94GAYw3+puxnSR+/iCkV61bt5qwYCbq
# aVchXTQvH3Gwg5QZBWs1kBCge5fH9j/n4hFBpr1i2fAnPTgdKG86Ugnw7HBi02JL
# sOBzppLA044x2C/jbRcTBu7kA7YUq/OPQ6dxnSHdFMoVXZJB2vkPgdGZdA0mxA5/
# G7X1oPHGdwYoFenYk+VVFvC7Cqsc21xIJ2bIo4sKHOWV2q7ELlmgYd3a822iYemK
# C23sEhi991VUQAOSK2vCUcIKSK+w1G7g9BQKOhvjjz3Kr2qNe9zYRDCCBs0wggW1
# oAMCAQICEAb9+QOWA63qAArrPye7uhswDQYJKoZIhvcNAQEFBQAwZTELMAkGA1UE
# BhMCVVMxFTATBgNVBAoTDERpZ2lDZXJ0IEluYzEZMBcGA1UECxMQd3d3LmRpZ2lj
# ZXJ0LmNvbTEkMCIGA1UEAxMbRGlnaUNlcnQgQXNzdXJlZCBJRCBSb290IENBMB4X
# DTA2MTExMDAwMDAwMFoXDTIxMTExMDAwMDAwMFowYjELMAkGA1UEBhMCVVMxFTAT
# BgNVBAoTDERpZ2lDZXJ0IEluYzEZMBcGA1UECxMQd3d3LmRpZ2ljZXJ0LmNvbTEh
# MB8GA1UEAxMYRGlnaUNlcnQgQXNzdXJlZCBJRCBDQS0xMIIBIjANBgkqhkiG9w0B
# AQEFAAOCAQ8AMIIBCgKCAQEA6IItmfnKwkKVpYBzQHDSnlZUXKnE0kEGj8kz/E1F
# kVyBn+0snPgWWd+etSQVwpi5tHdJ3InECtqvy15r7a2wcTHrzzpADEZNk+yLejYI
# A6sMNP4YSYL+x8cxSIB8HqIPkg5QycaH6zY/2DDD/6b3+6LNb3Mj/qxWBZDwMiEW
# icZwiPkFl32jx0PdAug7Pe2xQaPtP77blUjE7h6z8rwMK5nQxl0SQoHhg26Ccz8m
# SxSQrllmCsSNvtLOBq6thG9IhJtPQLnxTPKvmPv2zkBdXPao8S+v7Iki8msYZbHB
# c63X8djPHgp0XEK4aH631XcKJ1Z8D2KkPzIUYJX9BwSiCQIDAQABo4IDejCCA3Yw
# DgYDVR0PAQH/BAQDAgGGMDsGA1UdJQQ0MDIGCCsGAQUFBwMBBggrBgEFBQcDAgYI
# KwYBBQUHAwMGCCsGAQUFBwMEBggrBgEFBQcDCDCCAdIGA1UdIASCAckwggHFMIIB
# tAYKYIZIAYb9bAABBDCCAaQwOgYIKwYBBQUHAgEWLmh0dHA6Ly93d3cuZGlnaWNl
# cnQuY29tL3NzbC1jcHMtcmVwb3NpdG9yeS5odG0wggFkBggrBgEFBQcCAjCCAVYe
# ggFSAEEAbgB5ACAAdQBzAGUAIABvAGYAIAB0AGgAaQBzACAAQwBlAHIAdABpAGYA
# aQBjAGEAdABlACAAYwBvAG4AcwB0AGkAdAB1AHQAZQBzACAAYQBjAGMAZQBwAHQA
# YQBuAGMAZQAgAG8AZgAgAHQAaABlACAARABpAGcAaQBDAGUAcgB0ACAAQwBQAC8A
# QwBQAFMAIABhAG4AZAAgAHQAaABlACAAUgBlAGwAeQBpAG4AZwAgAFAAYQByAHQA
# eQAgAEEAZwByAGUAZQBtAGUAbgB0ACAAdwBoAGkAYwBoACAAbABpAG0AaQB0ACAA
# bABpAGEAYgBpAGwAaQB0AHkAIABhAG4AZAAgAGEAcgBlACAAaQBuAGMAbwByAHAA
# bwByAGEAdABlAGQAIABoAGUAcgBlAGkAbgAgAGIAeQAgAHIAZQBmAGUAcgBlAG4A
# YwBlAC4wCwYJYIZIAYb9bAMVMBIGA1UdEwEB/wQIMAYBAf8CAQAweQYIKwYBBQUH
# AQEEbTBrMCQGCCsGAQUFBzABhhhodHRwOi8vb2NzcC5kaWdpY2VydC5jb20wQwYI
# KwYBBQUHMAKGN2h0dHA6Ly9jYWNlcnRzLmRpZ2ljZXJ0LmNvbS9EaWdpQ2VydEFz
# c3VyZWRJRFJvb3RDQS5jcnQwgYEGA1UdHwR6MHgwOqA4oDaGNGh0dHA6Ly9jcmwz
# LmRpZ2ljZXJ0LmNvbS9EaWdpQ2VydEFzc3VyZWRJRFJvb3RDQS5jcmwwOqA4oDaG
# NGh0dHA6Ly9jcmw0LmRpZ2ljZXJ0LmNvbS9EaWdpQ2VydEFzc3VyZWRJRFJvb3RD
# QS5jcmwwHQYDVR0OBBYEFBUAEisTmLKZB+0e36K+Vw0rZwLNMB8GA1UdIwQYMBaA
# FEXroq/0ksuCMS1Ri6enIZ3zbcgPMA0GCSqGSIb3DQEBBQUAA4IBAQBGUD7Jtygk
# pzgdtlspr1LPUukxR6tWXHvVDQtBs+/sdR90OPKyXGGinJXDUOSCuSPRujqGcq04
# eKx1XRcXNHJHhZRW0eu7NoR3zCSl8wQZVann4+erYs37iy2QwsDStZS9Xk+xBdIO
# PRqpFFumhjFiqKgz5Js5p8T1zh14dpQlc+Qqq8+cdkvtX8JLFuRLcEwAiR78xXm8
# TBJX/l/hHrwCXaj++wc4Tw3GXZG5D2dFzdaD7eeSDY2xaYxP+1ngIw/Sqq4AfO6c
# Qg7PkdcntxbuD8O9fAqg7iwIVYUiuOsYGk38KiGtSTGDR5V3cdyxG0tLHBCcdxTB
# nU8vWpUIKRAmMYIEQzCCBD8CAQEwgYYwcjELMAkGA1UEBhMCVVMxFTATBgNVBAoT
# DERpZ2lDZXJ0IEluYzEZMBcGA1UECxMQd3d3LmRpZ2ljZXJ0LmNvbTExMC8GA1UE
# AxMoRGlnaUNlcnQgU0hBMiBBc3N1cmVkIElEIENvZGUgU2lnbmluZyBDQQIQBpmU
# 8wCaohbRt3PpZzMSrDANBglghkgBZQMEAgEFAKB8MBAGCisGAQQBgjcCAQwxAjAA
# MBkGCSqGSIb3DQEJAzEMBgorBgEEAYI3AgEEMBwGCisGAQQBgjcCAQsxDjAMBgor
# BgEEAYI3AgEVMC8GCSqGSIb3DQEJBDEiBCCoyRizbMRg83OHxzd/0eruheLgwMjt
# 0xMHVqvZfMy7wjANBgkqhkiG9w0BAQEFAASCAQA5t9Hm6VRQLY4zw7B88eIUUc1x
# T2K2mO6mPw7weo6MHL3B1DpOub8204V2n+fy4LdmqIuIX8CNW/BkWEZnZkRPYuWo
# HITvNgE/LijoYiMIuNglxtleDFHrD8shSaVTove3mHi0yGq3lUMMma2AQ8AhQKAO
# d9g1IZ9sxB2ZGmSBr7BiKNG2DMXwbLxnHOkn9WWb92Puxv7eQdbI3bRlRWKxxXPv
# P3b3X9IX4vxIYl/DJl6+UXFVjeIHBKIJCEJpAPgHZ/HA6qJtmn/E72EX2hRPabtx
# KM9m+6BNd+3pouuGKSjvL7nibiBcZQHPEEHoTd7I64/k9TR3KOveXXbePiE0oYIC
# DzCCAgsGCSqGSIb3DQEJBjGCAfwwggH4AgEBMHYwYjELMAkGA1UEBhMCVVMxFTAT
# BgNVBAoTDERpZ2lDZXJ0IEluYzEZMBcGA1UECxMQd3d3LmRpZ2ljZXJ0LmNvbTEh
# MB8GA1UEAxMYRGlnaUNlcnQgQXNzdXJlZCBJRCBDQS0xAhADAZoCOv9YsWvW1erm
# F/BmMAkGBSsOAwIaBQCgXTAYBgkqhkiG9w0BCQMxCwYJKoZIhvcNAQcBMBwGCSqG
# SIb3DQEJBTEPFw0yMDA2MjAxMzM3MDlaMCMGCSqGSIb3DQEJBDEWBBQ0jKWNm1gK
# vxja7CtdC+ZrtHRpUDANBgkqhkiG9w0BAQEFAASCAQBp5NzGom2UENiDE0Fwpr7/
# 5YDOafenKpRoMZs0hWiIpf9ryS+0KFi8lPGZjRzJSwKZCNJjB0Y/en4QZbL1BFdl
# 02UVklq1DArathgKmKjmjLvvsw84WY23fexyB0F2Vs0UDKEcl15KkTMAMQSNpiF+
# 42YmEQLQ+LIcVyvh7cPeDNTXMhlCw1LgZjoj49rA10FhyBXfmKUor8H1WNSPsgUJ
# 0J41mnexfSnukA1UDHffpcYwhRZ54R5gw7wFxQP3icLGHpK4zyZxU6ixC1oSy7/4
# SladhdfR1TWzguCAQm5wrEyT6J6TrH/3juIyEd5tTUD+6b2SdeWNBZTbmeW1ZMVf
# SIG # End signature block
